/** @file counter_coverage.cpp
 * This file contains implementation of the coverage class.
 *
 * @author Mikhail Chupilko (chupilko@ispras.ru)
 */

#include <counter_coverage.h>
#include <counter_model.h>

namespace cpptesk {
namespace examples {
namespace counter {

CounterCoverage::Counter_BitSet CounterCoverage::cov_BitSet(void) const
{
    switch(counter.get_value()) {
        case 0:  return CounterCoverage::Counter_BitSet::I0;
        case 1:  return CounterCoverage::Counter_BitSet::I1;
        case 2:  return CounterCoverage::Counter_BitSet::I2;
        case 3:  return CounterCoverage::Counter_BitSet::I3;
        case 4:  return CounterCoverage::Counter_BitSet::I4;
        case 5:  return CounterCoverage::Counter_BitSet::I5;
        case 6:  return CounterCoverage::Counter_BitSet::I6;
        case 7:  return CounterCoverage::Counter_BitSet::I7;
        default: assert(false);
    }
}

void CounterCoverage::out_cov(void) {
      coverageTracker << CounterCoverage::cov_BitSet();
}

}}}
