/** @file fifo_coverage.cpp
 *  .
 *
 * @author   (chupilko@ispras.ru)
 */

#include <fifo_coverage.h>
#include <fifo_model.h>

namespace cpptesk {
namespace examples {
namespace fifo {

FIFOCoverage::FIFO_FULNESS_HIGH FIFOCoverage::cov_FF_high(int fulness) const
{
    switch(fulness) {
        case 0:  return FIFOCoverage::FIFO_FULNESS_HIGH::I0;
        case 1:  return FIFOCoverage::FIFO_FULNESS_HIGH::I1;
        case 2:  return FIFOCoverage::FIFO_FULNESS_HIGH::I2;
        case 3:  return FIFOCoverage::FIFO_FULNESS_HIGH::I3;
        case 4:  return FIFOCoverage::FIFO_FULNESS_HIGH::I4;
        case 5:  return FIFOCoverage::FIFO_FULNESS_HIGH::I5;
        case 6:  return FIFOCoverage::FIFO_FULNESS_HIGH::I6;
        case 7:  return FIFOCoverage::FIFO_FULNESS_HIGH::I7;
        case 8:  return FIFOCoverage::FIFO_FULNESS_HIGH::I8;
        case 9:  return FIFOCoverage::FIFO_FULNESS_HIGH::I9;
        case 10: return FIFOCoverage::FIFO_FULNESS_HIGH::I10;
        case 11: return FIFOCoverage::FIFO_FULNESS_HIGH::I11;
        case 12: return FIFOCoverage::FIFO_FULNESS_HIGH::I12;
        case 13: return FIFOCoverage::FIFO_FULNESS_HIGH::I13;
        case 14: return FIFOCoverage::FIFO_FULNESS_HIGH::I14;
        case 15: return FIFOCoverage::FIFO_FULNESS_HIGH::I15;
        case 16: return FIFOCoverage::FIFO_FULNESS_HIGH::I16;
        default: assert(false);
    }
}

FIFOCoverage::FIFO_FULNESS_LOW FIFOCoverage::cov_FF_low(int fulness) const
{
    return FIFOCoverage::cov_FF_high(fulness);
}

FIFOCoverage::FIFO_FULNESS_UNITED FIFOCoverage::cov_FF_united(int fulness) const
{
    return FIFOCoverage::cov_FF_high(fulness & 0xF) * FIFOCoverage::cov_FF_low(fulness >> 4);
}

void FIFOCoverage::out_cov_FF(void) {
      coverageTracker << FIFOCoverage::cov_FF_high(fifo.fifo_fulness() >> 4);
      coverageTracker << FIFOCoverage::cov_FF_low(fifo.fifo_fulness() & 0xF);
      coverageTracker << FIFOCoverage::cov_FF_united(fifo.fifo_fulness());
}

}}}
