/** @file fifo_coverage.h
 *     .
 *
 * @author   (chupilko@ispras.ru)
 */

#pragma once

#define CPPTESK_SHORT_SHORT_NAMES

#include <hw/model.hpp>
#include <ts/coverage.hpp>
#include <tracer/tracer.hpp>

using namespace cpptesk::ts;
using namespace cpptesk::hw;
using namespace cpptesk::tracer::coverage;

namespace cpptesk {
namespace examples {
namespace fifo {

///     .
class FIFO;

///     .
class FIFOCoverage {
public:
    FIFOCoverage(FIFO &fifo): fifo(fifo) {}

    ///  .
    CoverageTracker coverageTracker;

    ///     .
    ENUM_COV(FIFO_FULNESS, "FIFO fulness", (
                                      (I0, "0"),
                                      (I1, "1"),
                                      (I2, "2"),
                                      (I3, "3"),
                                      (I4, "4"),
                                      (I5, "5"),
                                      (I6, "6"),
                                      (I7, "7"),
                                      (I8, "8"),
                                      (I9, "9"),
                                      (I10, "A"),
                                      (I11, "B"),
                                      (I12, "C"),
                                      (I13, "D"),
                                      (I14, "E"),
                                      (I15, "F"),
                                      (I16, "other")
                                      ));
    ALIAS_COV(FIFO_FULNESS_LOW, "FIFO fulness low", FIFO_FULNESS);
    ALIAS_COV(FIFO_FULNESS_HIGH, "FIFO fulness high", FIFO_FULNESS);
    COMP_COV(FIFO_FULNESS_UNITED, "FIFO fulness total", FIFO_FULNESS_HIGH, FIFO_FULNESS_LOW);

    ///          .
    FIFO_FULNESS_HIGH cov_FF_high(int fulness) const;
    FIFO_FULNESS_LOW cov_FF_low(int fulness) const;
    FIFO_FULNESS_UNITED cov_FF_united(int fulness) const;

    ///   .
    void out_cov_FF(void);

protected:
    ///    .
    FIFO &fifo;
};

}}}

