#include <netfsm/engines.hpp>

#include "account_scen.h"

using namespace cpptesk::ts;

template<typename C>
void print_coverage(cpptesk::tracer::coverage::CoverageTracker& ct) {
	std::cout << "Coverage " << C::name() << std::endl;
	for(typename C::ElementIterator i = C::begin(); i != C::end(); ++i) {
		std::cout << "  " << (*i).label << " : " << ct[C((*i).id)] << std::endl;
	}
}

CPPTESK_DEFINE_ALIAS_COVERAGE(Alias_Cov, "Alias", AccountModel::DepositStart);

int main(int argc, char **argv) {
	Account impl(-3);

	AccountScenario scenario(5, &impl);

	cpptesk::ts::localmain(cpptesk::ts::engine::fsm, scenario.getTestScenario(), argc, argv);

	std::cout<< "------------------" << std::endl;
	print_coverage<AccountModel::DepositStart>(scenario.mediator.coverage);
	std::cout<< "------------------" << std::endl;
	print_coverage<AccountModel::DepositEnd>(scenario.mediator.coverage);
	std::cout<< "------------------" << std::endl;
	print_coverage<AccountModel::Deposit>(scenario.mediator.coverage);
	std::cout<< "------------------" << std::endl;
	print_coverage<AccountModel::WithdrawStart>(scenario.mediator.coverage);
	std::cout<< "------------------" << std::endl;
	print_coverage<AccountModel::WithdrawEnd>(scenario.mediator.coverage);
	std::cout<< "------------------" << std::endl;
	print_coverage<AccountModel::Withdraw>(scenario.mediator.coverage);
	std::cout<< "------------------" << std::endl;
	AccountModel::DepositStart x = AccountModel::DepositStart::NEGATIVE;
	Alias_Cov y = x;
	Alias_Cov z = x.id;
	return 0;
}
